<template lang="pug">
q-card.q-my-md(flat, bordered)
  q-card-section(horizontal)
    q-card-section.col
      span.material-icons(style="font-size: 36px; color: #027be3") description
      span.vertical-middle.text-h5.vspace1.ellipsis {{ doc.title }}
    q-separator(vertical)
    q-card-actions.justify-around.q-px-md
      q-btn.gdoc-tile-btn(
        :loading="deleteLoading",
        :disabled="isAnonymous",
        flat,
        round,
        type="a",
        v-on:click="removeDocument",
        icon="delete",
        color="grey-6"
      )
        q-tooltip Delete this document
      q-btn.gdoc-tile-btn(
        :disabled="isAnonymous",
        flat,
        round,
        type="a",
        v-on:click="editDocument",
        icon="edit",
        color="grey-6"
      )
        q-tooltip Edit this document
      q-btn.gdoc-tile-btn(
        flat,
        round,
        type="a",
        v-on:click="viewDocument",
        icon="remove_red_eye",
        color="grey-6"
      )
        q-tooltip View this document
      q-btn.gdoc-tile-btn(
        :loading="distributeLoading",
        flat,
        round,
        type="a",
        v-on:click="distributeDocument",
        icon="message",
        :class="{ disabled: this.doc.distributed || !canDistribute }",
        color="positive"
      )
        q-tooltip Copy and distribute to participants
</template>

<script>
import { getSessionToken } from "../shared";

export default {
  name: "GDocTile",
  props: ["doc", "docId", "meeting", "canDistribute"],
  data() {
    return {
      loading: false,
      distributeLoading: false,
      deleteLoading: false,
    };
  },
  created() {
    this.getSessionToken = getSessionToken;
  },
  filters: {},
  computed: {
    distributeLabel() {
      return this.doc.distributed ? "Distributed" : "Distribute";
    },
    isAnonymous() {
      return Boolean(this.$cookies.get("anonymous"));
    },
  },
  methods: {
    viewDocument: function () {
      window.open(`https://docs.google.com/document/d/${this.docId}`, "_blank");
    },
    removeDocument: async function () {
      if (this.loading || this.isAnonymous) return;

      this.deleteLoading = true;

      var body = {
        meetingId: this.meeting[".key"],
        documentId: this.docId,
      };

      var token = await this.getSessionToken();

      this.$http
        .delete(
          `${process.env.VUE_APP_FB_FUNCTIONS}/googleDocsDeleteDocument`,
          {
            headers: { Authorization: `Bearer ${token}` },
            data: body,
          },
        )
        .then(() => {
          // TODO make this pretty
          this.$q.notify({
            type: "positive",
            message: `Document deleted`,
          });
          //- window.alert("Document deleted");
          this.deleteLoading = false;
        })
        .catch(error => {
          this.deleteLoading = false;
          // TODO make this pretty
          //- window.alert("There was an error, please try again", error);
          this.$q.notify({
            type: "negative",
            message: `There was an error, please try again`,
          });
          console.error("Document submission", error);
        });
    },
    editDocument: function () {
      if (this.loading || this.isAnonymous) return;

      // TODO confirmation (user will lose any changes manually made to the document)
      this.$router.push(
        `/adddoc/${this.meeting[".key"]}/?existingDoc=${this.docId}`,
      );
    },
    distributeDocument: async function () {
      if (this.doc.distributed || this.loading || !this.canDistribute) return;

      this.distributeLoading = true;

      var token = await this.getSessionToken();
      const reqConfig = {
        headers: { Authorization: `Bearer ${token}` },
      };

      var body = {
        meetingId: this.meeting[".key"],
        documentId: this.docId,
        roomIds: [],
      };

      // TODO choose what rooms it should be distributed to - currently will send to all
      for (var i = 1; i <= this.meeting.noOfBreakoutRooms; i++) {
        body.roomIds.push(`ZoomSensor_${i}`);
      }

      // For anonymous users, pass the hostuid when trying to distribute the docs
      const anonymous = this.$cookies.get("anonymous");
      if (anonymous) body.hostId = anonymous.hostuid;

      this.$http
        .post(
          `${process.env.VUE_APP_FB_FUNCTIONS}/googleDocsDistributeAndStartWatchingCopies`,
          body,
          reqConfig,
        )
        .then(() => {
          this.$q.notify({
            type: "positive",
            message: `Document distributed!`,
          });
          //- window.alert("Document distributed!");
          // this.loading = false;
          this.distributeLoading = false;
        })
        .catch(error => {
          //- window.alert("There was an error, please try again. \n" + error);
          this.$q.notify({
            type: "negative",
            message: `There was an error, please try again.`,
          });
          console.error("distribute doc error", error);
          // this.loading = false;
          this.distributeLoading = false;
        });
    },
  },
  components: {},
};
</script>

<style scoped>
.disabled {
  opacity: 0.1 !important;
}

.gdoc-tile-btn {
  margin-left: 5px;
  margin-right: 5px;
}
</style>